summaryrefslogtreecommitdiff
path: root/Omni/Ide/ns.sh
diff options
context:
space:
mode:
authorBen Sima <ben@bsima.me>2024-11-15 14:55:37 -0500
committerBen Sima <ben@bsima.me>2024-12-21 10:06:49 -0500
commit6513755670892983db88a6633b8c1ea6019c03d1 (patch)
tree44e9eccdb7a3a74ab7e96a8fee7572dd6a78dc73 /Omni/Ide/ns.sh
parentae7b7e0186b5f2e0dcd4d5fac0a71fa264caedc2 (diff)
Re-namespace some stuff to Omni
I was getting confused about what is a product and what is internal infrastructure; I think it is good to keep those things separate. So I moved a bunch of stuff to an Omni namespace, actually most stuff went there. Only things that are explicitly external products are still in the Biz namespace.
Diffstat (limited to 'Omni/Ide/ns.sh')
-rwxr-xr-xOmni/Ide/ns.sh50
1 files changed, 50 insertions, 0 deletions
diff --git a/Omni/Ide/ns.sh b/Omni/Ide/ns.sh
new file mode 100755
index 0000000..a56ed89
--- /dev/null
+++ b/Omni/Ide/ns.sh
@@ -0,0 +1,50 @@
+#!/usr/bin/env bash
+set -euo pipefail
+nss="fd --color=always --exclude=_ -t f . \"${CODEROOT:?}\" | sed \"s,${CODEROOT:?}/*,,g\""
+keybindings=$(cat <<EOF
+repl {}:enter
+repl --bash {}:alt+enter
+edit {} with $EDITOR:tab
+lint -f {}:alt+c
+bild {}:alt+space
+bild --test {}:alt+t
+exec {}:alt+e
+ship {}:ctrl+space
+create new namespace:alt+n
+change preview window:alt+0-6
+resize preview window:ctrl+/
+EOF
+)
+fzf_flags=(
+ --ansi
+ --bind "focus:transform-preview-label:echo {}"
+ --bind "?:change-preview(column -o ' -> ' -s':' -t <<< \"$keybindings\")"
+ --bind "alt-n:execute(touch {q})+reload($nss)"
+ --bind "alt-space:execute(bild {} ; read -p [fin])"
+ --bind "tab:execute($EDITOR {})"
+ --bind "alt-c:execute(lint -f {} ; read -p [fin])"
+ --bind "enter:execute(repl.sh {})"
+ --bind "alt-enter:execute(repl.sh --bash {})"
+ --bind "ctrl-space:execute(ship.sh {} ; read -p [fin])"
+ --bind "alt-t:execute(bild {} ; run.sh {} test ; read -p [fin])"
+ --bind "ctrl-/:change-preview-window(right,88|right,70%|hidden|)"
+ --bind "alt-0:change-preview(bat -p --color=always {})"
+ --bind "alt-1:change-preview(git log --color=always --date=relative --abbrev-commit --pretty=format:'%Cred%h%Creset %s / %an %Creset%C(yellow)%d%Creset%Cgreen(%cr)%Creset' -- {})"
+ --bind "alt-2:change-preview(git log --color=always {})"
+ --bind "alt-3:change-preview(git log --color=always -p {})"
+ --bind "alt-4:change-preview(git blame -c --date=short {})"
+ --bind "alt-5:change-preview(git log --pretty=short {} | git shortlog -nse)"
+ --bind "alt-6:change-preview(git log --pretty=short {} | git shortlog)"
+ --bind "backward-eof:abort"
+ --bind "pgup:preview-page-up"
+ --bind "pgdn:preview-page-down"
+ --header-first
+ --header="? for keybindings"
+ --border=top
+ --border-label="$(lolcat -f <<< "hack a namespace")"
+ --color=label:italic
+ --preview-window="bottom,80%"
+ --preview "bat -p --color=always {}"
+)
+sh -c "$nss" | fzf "${fzf_flags[@]}"
+